package jp.deadend.noname.ntl;

import android.content.Context;
import android.view.MotionEvent;
import android.view.ScaleGestureDetector;
import android.util.AttributeSet;
import android.widget.ListView;
import android.util.Log;

import java.util.List;

public class AppListView extends ListView {
	private ScaleGestureDetector mSGD;

	public AppListView(Context context) {
		super(context);
		init(context);
	}

	public AppListView(Context context, AttributeSet attrs) {
		super(context, attrs);
		init(context);
	}

	public AppListView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		init(context);
	}

	private void init(Context context) {
		mSGD = new ScaleGestureDetector(context, new ScaleListener());
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		mSGD.onTouchEvent(event);
		return super.onTouchEvent(event);
	}

	private class ScaleListener extends ScaleGestureDetector.SimpleOnScaleGestureListener {
		@Override
		public boolean onScale(ScaleGestureDetector detector) {
			AppListAdapter adapter = (AppListAdapter)getAdapter();
			if (adapter == null) return false;

			int fontSize = Math.round(adapter.getFontSize()*detector.getScaleFactor());
			adapter.setFontSize(fontSize);

			invalidateViews();
			return true;
		}
	}
}
