package jp.deadend.noname.ntl;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;

import java.util.ArrayList;
import java.util.List;

public class InstallReceiver extends BroadcastReceiver {
	@Override
	public void onReceive(Context context, Intent intent) {
		PackageManager pm = context.getPackageManager();
		String packageName = intent.getData().getSchemeSpecificPart();

		Intent targetIntent = new Intent(Intent.ACTION_MAIN, null);
		targetIntent.addCategory(Intent.CATEGORY_LAUNCHER);
		targetIntent.setPackage(packageName);

		List<AppNameInfo> result = new ArrayList<AppNameInfo>();
		for (ResolveInfo ri : pm.queryIntentActivities(targetIntent, 0)) {
			String appName = ri.loadLabel(pm).toString();
			ActivityInfo ai = ri.activityInfo;
			if (appName == null) {
				appName = ai.name;
			} else if (appName.length() == 0) {
				appName = ai.name;
			}

			result.add(new AppNameInfo(appName, ai.packageName, ai.name));
		}

		CacheFile.saveCache(context, result, true);
	}
}
