package jp.deadend.noname.ntl;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ActivityInfo;
import android.content.pm.ApplicationInfo;
import android.content.pm.ResolveInfo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

class LoadAppList {
	static List<AppNameInfo> load(Context context) {
		PackageManager pm = context.getPackageManager();
		Intent intent = new Intent(Intent.ACTION_MAIN, null);
		intent.addCategory(Intent.CATEGORY_LAUNCHER);
		List<ResolveInfo> activities = pm.queryIntentActivities(intent, 0);

		List<AppNameInfo> result = new ArrayList<AppNameInfo>(activities.size());
		if (activities.size() > 0) {
			for (ResolveInfo ri : activities) {
				String appName = ri.loadLabel(pm).toString();
				if (appName == null){
					appName = "no name";
				}
				if (appName.equals(context.getString(R.string.app_name))) {
					continue;
				}
				ActivityInfo ai = ri.activityInfo;
				result.add(new AppNameInfo(appName, ai.packageName, ai.name));
			}

			Collections.sort(result);
			CacheFile.saveCache(context, result, false);
		}

		return result;
	}
}
