package jp.deadend.noname.ntl;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import java.util.ArrayList;
import java.util.List;

public class UninstallReceiver extends BroadcastReceiver {
	@Override
	public void onReceive(Context context, Intent intent) {
		String packageName = intent.getData().getSchemeSpecificPart();

		CacheFile.saveCache(context, removeAppInfo(CacheFile.loadCache(context), packageName), false);
		CacheFile.saveRecentList(context, removeAppInfo(CacheFile.loadRecentList(context), packageName));
	}

	private List<AppNameInfo> removeAppInfo(List<AppNameInfo> apps, String packageName) {
		List<AppNameInfo> newApps = new ArrayList<AppNameInfo>(apps.size());
		for (AppNameInfo app : apps) {
			if (!packageName.equals(app.packageName)) {
				newApps.add(app);
			}
		}

		return newApps;
	}
}
